From 42e86fcc42ce60f8c92f3c7d5f3a6ccde47c0b33 Mon Sep 17 00:00:00 2001
From: Gerlof Langeveld <gerlof.langeveld@atoptool.nl>
Date: Sat, 25 Mar 2017 14:36:13 +0100
Subject: [PATCH] Preparation for github

---
 Makefile  | 2 +-
 version.h | 2 ++
 2 files changed, 3 insertions(+), 1 deletion(-)
 create mode 100644 version.h

diff --git a/Makefile b/Makefile
index a6583f8..073df34 100644
--- a/Makefile
+++ b/Makefile
@@ -45,7 +45,7 @@ netlink.o:	netlink.c
 
 clean:
 		rm -f *.o
-		rm atop atopsar atopacctd
+		rm atop atopacctd
 
 distr:
 		rm -f *.o atop
diff --git a/version.h b/version.h
new file mode 100644
index 0000000..f298461
--- /dev/null
+++ b/version.h
@@ -0,0 +1,2 @@
+#define	ATOPVERS	"2.3.0"
+#define	ATOPDATE	"2017/03/25 09:59:59"