--- sendlib.c.orig	2004-01-26 18:47:31.000000000 -0500
+++ sendlib.c	2004-01-26 18:49:52.000000000 -0500
@@ -2389,7 +2389,10 @@ int mutt_write_fcc (const char *path, HE
    */
   if (post && fcc)
     fprintf (msg->fp, "X-Mutt-Fcc: %s\n", fcc);
-  fprintf (msg->fp, "Status: RO\n");
+#ifdef USE_IMAP
+  if (f.magic != M_IMAP)
+#endif
+    fprintf (msg->fp, "Status: RO\n");
 
 
 