diff -dur mutt-1.5.7/compose.c mutt-1.5.7-nntpfix/compose.c
--- mutt-1.5.7/compose.c	2005-02-11 21:19:45.570738048 +0000
+++ mutt-1.5.7-nntpfix/compose.c	2005-02-11 21:20:44.990704840 +0000
@@ -61,6 +61,9 @@
   HDR_REPLYTO,
   HDR_FCC,
 
+#ifdef MIXMASTER
+  HDR_MIX,
+#endif
 
   HDR_CRYPT,
   HDR_CRYPTINFO,