diff -ruN VDR.org/PLUGINS/src/yaepg-0.0.2.1-rev2/patches/vdr-1.3.23-core-yaepg.diff VDR/PLUGINS/src/yaepg-0.0.2.1-rev2/patches/vdr-1.3.23-core-yaepg.diff
--- VDR.org/PLUGINS/src/yaepg-0.0.2.1-rev2/patches/vdr-1.3.23-core-yaepg.diff	2006-01-13 18:18:29.000000000 +0100
+++ VDR/PLUGINS/src/yaepg-0.0.2.1-rev2/patches/vdr-1.3.23-core-yaepg.diff	2006-01-13 18:19:04.000000000 +0100
@@ -5475,7 +5475,7 @@
 @@ -586,6 +586,7 @@
    top = Top;
    width = height = 0;
-   isOpen = true;
+   isOpen++;
 +  vidWin.bpp = 0;
  }
  
diff -ruN VDR.org/PLUGINS/src/yaepg-0.0.2.1-rev2/yaepg.c VDR/PLUGINS/src/yaepg-0.0.2.1-rev2/yaepg.c
--- VDR.org/PLUGINS/src/yaepg-0.0.2.1-rev2/yaepg.c	2006-01-13 18:18:29.000000000 +0100
+++ VDR/PLUGINS/src/yaepg-0.0.2.1-rev2/yaepg.c	2006-01-13 18:20:19.000000000 +0100
@@ -7,6 +7,7 @@
  */
 
 #include "yaepg.h"
+#include <vdr/device.h>
 
 #define EPGWinHandle		areas[0]
 #define InfoWinHandle		areas[1]
@@ -670,12 +671,12 @@
 	time_t			startTime;
 
 public:
-	cNoInfoEvent(time_t, tChannelID);
+	cNoInfoEvent(time_t);
 	~cNoInfoEvent();
 };
 
-cNoInfoEvent::cNoInfoEvent(time_t startTime, tChannelID chanId)
-	: cEvent(chanId, 0)
+cNoInfoEvent::cNoInfoEvent(time_t startTime)
+	: cEvent(0)
 {
 	SetStartTime(startTime);
 	SetDuration(9000);
@@ -1520,7 +1521,7 @@
 				 * If we didn't find an event at this time try
 				 * make a "No Info" evnet.
 				 */
-				currEvent = new cNoInfoEvent(grTime, chans[i]->GetChanID());
+				currEvent = new cNoInfoEvent(grTime);
 				if (currEvent == NULL) {
 					fprintf(stderr, "NULL\n");
 				}
@@ -1670,7 +1671,11 @@
 
 		case kBlue:
 			/* Can this be fixed to work with NTSC ? */
+#if VDRVERSNUM >= 10338
+			cDevice::PrimaryDevice()->GrabImageFile("img.jpg",
+#else
 			cDevice::PrimaryDevice()->GrabImage("img.jpg",
+#endif
 					true, 256, -1, -1);
 			state = osContinue;
 			break;